set.seed(2018)

replicates <- 1000
aanr <- read.table("Supplementary_Material.csv",sep="\t",head=TRUE)
d <- split(aanr,aanr$Sample)
counted <- total <- observed_div <- rarefied_div <- rep(0,length(d))

for(i in seq_along(d)){
  uncounted <- 0
  n <- d[[i]]$N_total
  total[i] <- sum(n)
  counted[i] <- sum(d[[i]]$N_normal)+sum(d[[i]]$N_rare[d[[i]]$Estimated=="no"])
  observed_div[i] <- sum(n>0)
  n <- cbind(1:length(n),n)
  N <- as.character(unlist(apply(n,1,function(x)rep(x[1],x[2]))))
  S <- rep(0,replicates)
  for(j in 1:replicates){
    S[j] <- sum(table(sample(N,counted[i]))>0)
  }
  rarefied_div[i] <- mean(S)
  cat(i)
}
